#starter med  sette Executionpolicy for  kunne kjre scriptet
Set-ExecutionPolicy -ExecutionPolicy RemoteSigned -force

#vi installerer diverse Moduler for  kunne benytte oss av forskjellige kommandoer. Vi legger til -force for  slippe  bekrefte hver av installasjonene
Install-Module azuread -force
Install-Module windowsautopilotintune -force
Install-Module -Name Microsoft.Graph.Intune -force
Import-Module windowsautopilotintune -force
Install-Script -Name Get-WindowsAutoPilotInfo -force

#Vi kobler oss til Azure
connect-MSGraph

#prover  se om vi allerede har en tilkobling. Hvis ja kan vi benytte oss av den hvis ikke lager vi en ny tilkobling
$token = [Microsoft.Open.Azure.AD.CommonLibrary.AzureSession]::AccessTokens['AccessToken']
if($token -ne $null){
    Connect-AzureAD -AadAccessToken $token -AccountId admin@m365x750721.onmicrosoft.com
}else{
    Connect-AzureAD
}
#kobler oss til med en spesifikk bruker
Connect-AutoPilotIntune -user admin@m365x750721.onmicrosoft.com

#Vi henter ut Serienummeret, Os kode og Hashkoden til maskinen og lagrer den p en spesifikk lokasjon
Get-WindowsAutoPilotInfo.ps1 -OutputFile C:/AutoPilotHWID.csv

#Vi laster s opp CSV filen vi lagde over, opp til Azure
[void](Import-AutoPilotCSV -csvFile C:/AutoPilotHWID.csv)

#her henter vi ut Serienummeret til maskinen. Det finnes flere mter  gjre det p.
$DeviceID = get-ciminstance win32_bios | Select-Object -ExpandProperty serialnumber


#kjrer en Do...While istedet for en while for vi trenger  kjre den frst og s sjekke resultatet 
#Vi kjrer Do While helt til vi finner enheten med gitt Serienummer
#Vi knytter en bruker til maskinen med Serienummeret 
do{
$DALL = Get-AutoPilotDevice | Select-Object id, serialnumber | Where-Object -Property serialNumber -EQ $DeviceID
}while($dall.id -eq $null)
(Set-AutoPilotDeviceAssignedUser -id $DALL.id -userPrincipalName DE@M365x750721.onmicrosoft.com -displayName "Device Enroller")

#her har vi ogs en do while og starter med en pause p 30 sekunder
#S sjekker vi om Tokens er ok
#Til slutt sjekker vi om Enheten har ftt en enrollment Profile tilordnet seg. 
#Lkka repeteres hvert 30 sekund. Verdien kan endres.
do{
    Start-Sleep 30
    $token = [Microsoft.Open.Azure.AD.CommonLibrary.AzureSession]::AccessTokens['AccessToken']
    if($token -ne $null){

    }else{
        Connect-AzureAD
    
    }
    try{
    $DeviceHasProfile = Get-AutoPilotDevice | where {$_.deploymentProfileAssignmentStatus -eq "assignedUnkownSyncState" -and $_.serialnumber -eq $DALL.serialNumber} -ErrorAction Ignore
    }catch{
    }
}while($DeviceHasProfile -eq $null)

#nr enheten har ftt en profil vil vi f en melding om det og systemreset menyen dukker opp
Write-host "Its ready!" -ForegroundColor Green 

#-cleanPc vil beholde filer Vi kan velge -factoryreset for  velge  fjerne alt
systemreset -cleanpc